# 9. Embedded programming

[Group assignment](https://fabacademy.org/2022/labs/barcelona/students/barcelona-group-assignment/assignments/week08/embedded-programming/)

For this week assignment I made a board using the [SAMD11C14A](https://ww1.microchip.com/downloads/en/DeviceDoc/Atmel-42363-SAM-D11_Summary.pdf) with one button two programable LEDs and one control LED to know if the PCB is reciving power. 

![](../images/week09/outline_led_control_03.png)
![](../images/week09/traces_led_control_03.png)

Once the board is cuted and all the components are soldered is time to burn the bootloader, I am going to use edbd to do it. Once we have loaded the bootloader now we are able to program it using arduino.

![](../images/week09/edbg_bootloader.jpg)

Arduino will recognise the board in a port, just select the port and select the same board in the board manager, I am using the ***fab SAM core for arduino***.  

![](../images/week09/IMG_5574.JPG)

```
const int buttonPin = 4;     // the number of the pushbutton pin
const int ledPin =  14;      // the number of the LED pin
const int ledPin1 =  5;
boolean currentState = false;
boolean lastState = false;

void setup() {
  // initialize the LED pin as an output:
  pinMode(ledPin, OUTPUT);
  pinMode(ledPin1, OUTPUT);

  // initialize the pushbutton pin as an input:
  pinMode(buttonPin, INPUT);
}

void loop() {
  // read the state of the pushbutton value:
  if ((digitalRead(buttonPin) == 0) && (lastState == currentState)) {
    currentState = !currentState;
    if (currentState == true) {
      digitalWrite(ledPin, HIGH);
      digitalWrite(ledPin1, HIGH);
    }
    else {
      digitalWrite(ledPin, LOW);
      digitalWrite(ledPin1, LOW);
    }
  }
  else if (digitalRead(buttonPin) == 1) {
    lastState = currentState;
  }
  delay(0);
}
```

## SAM D11C 14A

A new generation of Atmel microcontrollers with SAMDs. A low-power, high-performance ARM® Cortex®-M0 + based flash microcontroller and with a full-speed USB device.

- 14 pin package.
- Internal and external clock options with 48MHDigital Frequency Locked Loop (DFLL48M) and 48MHto 96MHFractional.
- 16 KB Flash Memory.
- 256 B EEPROM.
- 4 KB SRAM.
- Maximum voltage: 3.63 V; minimum voltage: 1.62 


After looking at the basic features, you will find the pinning of the microcontroller. More information in this [link.](https://github.com/mattairtech/ArduinoCore-samd/tree/master/variants/Generic_D11C14A)

![+](../images/week09/pinout_samd11.jpg)

- VDD: Supply voltage.
- GND: Ground.
- Digital pins: PA02, PA04, PA05, PA08, PA09, PA14, PA15, PA31.
- Analog pins: PA02, PA04, PA05, PA14, PA15.
- USB pins: PA24, PA25.

All I/O pins can be configured with internal pull up or pull down resistance.


## FILES

[kicad](../files/embeded_programming/test_01.kicad_pro)
[PCB editor](../files/embeded_programming/test_01.kicad_pcb)
[schematic](../files/embeded_programming/test_01.kicad_sch)